=== core/dplugins/bqm/decorate/CMakeLists.txt ===
#
# Copyright (c) 2015-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

add_subdirectory(border)
add_subdirectory(watermark)
add_subdirectory(texture)
