=== core/dplugins/bqm/enhance/CMakeLists.txt ===
#
# Copyright (c) 2015-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

add_subdirectory(antivignetting)
add_subdirectory(blur)
add_subdirectory(localcontrast)
add_subdirectory(noisereduction)
add_subdirectory(redeyecorrection)
add_subdirectory(restoration)
add_subdirectory(sharpen)
add_subdirectory(hotpixels)

if(LensFun_FOUND)
    add_subdirectory(lensautofix)
endif()
