=== debian/changelog ===
digikam (4:7.1.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [05f5ebe] Add build-dep for libavdevice-dev to get working video support.
    Closes: #974889, #977297

 -- Steve M. Robbins <smr@debian.org>  Wed, 06 Jan 2021 20:35:40 -0600

digikam (4:7.1.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [2090afd] New upstream version 7.1.0.  Closes: #968494, #973656, #972612.
  * New upstream reported that following bugs are fixed: #721826, #731619.
  * [a5263e7] Refresh overrides.

 -- Steve M. Robbins <smr@debian.org>  Sun, 08 Nov 2020 23:16:09 -0600

digikam (4:7.0.0-1) experimental; urgency=medium

  [ Steve Robbins ]
  * [74b256e] New upstream version 7.0.0

 -- Steve M. Robbins <smr@debian.org>  Mon, 17 Aug 2020 21:56:17 -0500

digikam (4:7.0.0~beta2+dfsg-1) experimental; urgency=medium

  [ Steve Robbins ]
  * New upstream version 7.0.0-beta2

 -- Steve M. Robbins <smr@debian.org>  Mon, 17 Feb 2020 22:33:04 -0600
